'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = cleanupInputFields;
function cleanupInputFields(args, fragments) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var cleanedUpFragments = fragments;

  // tolerateMinification
  var dataArg = args.find(function (arg) {
    return arg.name === 'data';
  });
  var hasTolerateMinificationArg = dataArg && dataArg.type.inputFields.some(function (e) {
    return e.name === 'tolerateMinification';
  });

  if (!hasTolerateMinificationArg && typeof options.tolerateMinification !== 'undefined') {
    options.tolerateMinification = undefined;
    cleanedUpFragments = cleanedUpFragments.replace(/,?[\s|\n]*tolerateMinification/, '');
    console.warn('This API Version does not support the tolerateMinification argument.');
  }

  return [options, cleanedUpFragments];
}